/*-
 * ~~~~~~licensing~~~~~~
 * resource-based-storage
 * ==========
 * Copyright (C) 2020 - 2025 EmDev LLC
 * ==========
 * You may not use this file except in accordance with the License Terms of the Copyright
 * Holder located at: https://entaxy.ru/eula . All copyrights, all intellectual property
 * rights to the Software and any copies are the property of the Copyright Holder. Unless
 * it is explicitly allowed the Copyright Holder, the User is prohibited from using the
 * Software for commercial purposes to provide services to third parties.
 * 
 * The Copyright Holder hereby declares that the Software is provided on an "AS IS".
 * Under no circumstances does the Copyright Holder guarantee or promise that the
 * Software provided by him will be suitable or not suitable for the specific purposes
 * of the User, that the Software will meet all commercial and personal subjective
 * expectations of the User, that the Software will work properly, without technical
 * errors, quickly and uninterruptedly.
 * 
 * Under no circumstances shall the Copyright Holder or its Affiliates is not liable
 * to the User for any direct or indirect losses of the User, his expenses or actual
 * damage, including, downtime; loss of bussines; lost profit; lost earnings; loss
 * or damage to data, property, etc.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.platform.integration.applications.storage.resource.impl.application;

import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Optional;

public class ApplicationVersionData {

    String versionNumber;

    Map<String, String> revisions;

    public ApplicationVersionData(String versionNumber) {
        this.versionNumber = versionNumber;
    }

    public void addRevision(int revisionNumber, String timestamp) {
        addRevision(revisionNumber + "", timestamp);
    }

    public void addRevision(String revisionNumber, String timestamp) {
        if (revisions == null)
            revisions = new HashMap<>();
        if (!revisions.containsKey(revisionNumber))
            revisions.put(revisionNumber, timestamp);
    }

    public void removeRevision(int revisionNumber) {
        removeRevision(revisionNumber + "");
    }

    public void removeRevision(String revisionNumber) {
        if (revisions == null)
            return;
        revisions.remove(revisionNumber);
    }

    public String getLatestRevision() {
        Optional<Entry<String, String>> latest =
                revisions.entrySet().stream().sorted(new Comparator<Map.Entry<String, String>>() {

                    @Override
                    public int compare(Entry<String, String> o1, Entry<String, String> o2) {
                        // reverse order
                        return -1 * o1.getValue().compareTo(o2.getValue());
                    }
                }).findFirst();
        if (!latest.isPresent())
            return null;
        return latest.get().getKey();
    }

    public int getLastRevision() {
        if (revisions == null || revisions.isEmpty())
            return -1;
        return revisions.keySet().stream().mapToInt(v -> Integer.parseInt(v)).max().orElse(-1);
    }

    public List<String> getRevisionKeys() {
        if (revisions == null)
            return Collections.emptyList();
        return new ArrayList<>(revisions.keySet());
    }
}
